"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deriveTemplateModel = void 0;
const graphql_1 = require("graphql");
const deriveTemplateModel = async (options, answers, schema) => {
    const { portNumber = '8080', ...appAnswers } = answers;
    if (schema == null) {
        throw new Error("Schema is not provided (react-admin:app generator)");
    }
    return {
        ...appAnswers,
        portNumber,
        schema: graphql_1.printSchema(schema, { commentDescriptions: true }),
        generatorVersion: require('../../../../package.json').version,
    };
};
exports.deriveTemplateModel = deriveTemplateModel;
//# sourceMappingURL=template-model.js.map